/*********************************************************************/ 
/*                                                                   */ 
/*          Copyright 1985, Software Components Group, Inc.          */ 
/*                      ALL RIGHTS RESERVED                          */ 
/*                                                                   */ 
/*   This computer program is the property of Software Components    */ 
/*   Group Inc., Santa Clara, Calif., U.S.A. and may not be copied   */ 
/*   in any form or by any means, whether in part or in whole,       */ 
/*   except under license expressly granted by Software Components   */ 
/*   Group Inc.                                                      */ 
/*                                                                   */ 
/*   All copies of this program, whether in part or in whole, and    */ 
/*   whether modified or not, must display this and all other        */ 
/*   embedded copyright and ownership notices in full.               */ 
/*                                                                   */ 
/*-------------------------------------------------------------------*/
/*                                                                   */
/*   Copyright 1984, Green Hills Software, Inc.  This program is     */
/*   the property of Green Hills Software, Inc, its contents are     */
/*   proprietary information and no part of it is to be disclosed    */
/*   to anyone except employees of Green Hills Software, Inc., or    */
/*   as agreed to in writing signed by the President of Green Hills  */
/*   Software, Inc.                                                  */
/*                                                                   */
/*********************************************************************/
  
#define _U      1
#define _L      2
#define _N      4
#define _S      8 
#define _P      16 
#define _C      32 
#define _X      64
  
extern char ctype_[];
  
#define isalpha(ch) (ctype_[1+(ch)]&(_U|_L)) 
#define isupper(ch) (ctype_[1+(ch)]&(_U))
#define islower(ch) (ctype_[1+(ch)]&(_L))
#define isdigit(ch) (ctype_[1+(ch)]&(_N))
#define isspace(ch) (ctype_[1+(ch)]&(_S))
#define isxdigit(ch) (ctype_[1+(ch)]&(_N|_X))
#define iscntrl(ch)  (ctype_[1+(ch)]&(_C))
#define isprint(ch) (!(ctype_[1+(ch)]&(_C))) 
#define isgraph(ch) (ctype_[1+(ch)]&(_U|_L|_N|_P)) 
#define isalnum(ch) (ctype_[1+(ch)]&(_U|_L|_N))
#define ispunct(ch) (ctype_[1+(ch)]&(_P))
#define isascii(ch) ((unsigned) (ch)<=0x7f) 
#define toupper(ch) ((islower(ch)) ? (ch-'a'+'A') : ch)
#define tolower(ch) ((isupper(ch)) ? (ch-'A'+'a') : ch)
#define toascii(ch) (ch&0x7f) 
