
/*****************************************************************************/
/*                                                                           */
/*                	National Instruments GPIB-VXI Project                    */
/*						DownLoable Code Instruments							 */
/*                                                                           */
/*                     (C) 1989  National Instruments                        */
/*                                                                           */
/*****************************************************************************/
/*
 *	This file contains the definitions for all of the pSOS EVENT Signals used
 * for inter-process signaling.  Half of the Signals are used internally by
 * National Instruments and should not be used by DCIs.
 */

	/* GPIB-VXI Internally used Signals  0-7 */
#define S_EVENT_Res0		(1<<0)
#define S_EVENT_Res1		(1<<1)
#define S_EVENT_Res2		(1<<2)
#define S_EVENT_Res3		(1<<3)
#define S_EVENT_Res4		(1<<4)
#define S_EVENT_Res5		(1<<5)
#define S_EVENT_Res6		(1<<6)
#define S_EVENT_Res7		(1<<7)

	/* DCI defined events */
#define S_EVENT_BNO			(1<<8)		/* Begin Normal Operation occurred */
#define S_EVENT_DCI_IO		(1<<9)		/* Word Seria Data Buffer In or Data Out Request*/

	/* DCI user definable events--RENAME if desired */
#define S_EVENT_DCI_1		(1<<10)
#define S_EVENT_DCI_2		(1<<11)
#define S_EVENT_DCI_3		(1<<12)
#define S_EVENT_DCI_4		(1<<14)

	/* pSOS reserved events */
#define S_EVENT_pSOS_Reserved1	(1<<13)			/* child process died */
#define S_EVENT_pSOS_Reserved2	(1<<15)

