
***************************************************************************
*
*				National Instruments GPIB-VXI Project
*				   DCI User Library Function Caller 
*
*                  (c) 1989 National Instruments
*
***************************************************************************
*	The following file contains a stub user library as an example of how
* to create a DCI library.  
*	The idea is that a particular DCI is designated as a library holder 
* (or multiple DCI's or libraries).  The DCI that owns the library creates 
* a table of function pointers to the library functions and pokes in the 
* table address into one of the the User 'DCI_FunctionTable' addresses.  
* This will make it accessible to all other DCI's.  
*	All another DCI needs to know is the logical address of the DCI 
* library holder (which can be either known or figured out by the 
* Manufacturer/Model Code).  From the non-library holder DCI side, it needs
* to make a series of XDEF's (names for external definiton) for each of 
* the library functions with a subroutine to get to the appropriate funciton.
* This is the example that is contained in this file.
***************************************************************************

					SECTION 11


UserTableBase		equ		$60		* Static base of User jump tables in Header
OffsetSize			equ		$04		* Addresses are longwords

UserLibTableExample	equ		3		* which User jump table to use (0-4)


					xref	Lib_DCIheader

***************************************************************************
*						User Library Calls
***************************************************************************

******** Offsets into the Jump table ***********
N_UserFunc1		equ		0*OffsetSize
N_UserFunc2		equ		1*OffsetSize
N_UserFunc3		equ		2*OffsetSize
N_UserFunc4		equ		3*OffsetSize

******** Function names to XDEF ****************
				xdef	UserFunc1 
				xdef	UserFunc2 
				xdef	UserFunc3 
				xdef	UserFunc4 

******** Actual calls to functions *************
UserFunc1		move.l	#N_UserFunc1,D0
				bra.s	Handle_UserLib_Call
UserFunc2		move.l	#N_UserFunc2,D0
				bra.s	Handle_UserLib_Call
UserFunc3		move.l	#N_UserFunc3,D0
				bra.s	Handle_UserLib_Call
UserFunc4		move.l	#N_UserFunc4,D0
*				bra.s	Handle_UserLib_Call		* last branch not needed


************************************************************************************
* The following is the actual subroutine that jumps to the appropriate
* function when given the offset into the correct jump table.


UserTablePointer	equ		(UserTableBase+(UserLibTableExample*OffsetSize))

Handle_UserLib_Call:
				lea		Lib_DCIheader,A0		
				move.l	(A0),A0					*get address of library CI header
				adda.l	#UserTablePointer,A0	*index to jump table pointer
				move.l	(A0),A0					*get pointer to Jump Table
				move.l	0(A0,D0.W),A0			*get pointer to function
				jmp		(A0)					*jump to function
*												*function will return to caller directly

************************************************************************************

				end


