
/*****************************************************************************/
/*                                                                           */
/*                	National Instruments GPIB-VXI Project                    */
/*						DownLoable Code Instruments							 */
/*                                                                           */
/*                     (C) 1989  National Instruments                        */
/*                                                                           */
/*****************************************************************************/
/*	The following file in an example of how to create a user DCI library.
 * First the names should be externally referenced according to their correct
 * function type.  Second the table should be built.  This is done by creating
 * a static, pre-initialized array of unsigned longwords with the names of the 
 * functions as pre-initialized values.
 *	Finally, Before the DCI is brought up under normal operation (either in 
 * the pre-init routine or in a routine before received Begin Normal Operation,
 * the routine to poke in the address of the library should be called.  That
 * routine is called 'InitUserLibrary()' in this file.
 */

#include "DataSize.h"
#include "ResManIn.h"
#include "CommonBu.h"
#include "DciStruc.h"
#include "DciFuncs.h"


extern UserFunc1(), UserFunc2(), UserFunc3(), UserFunc4();

uint32	DCI_UserLib_Table[] = {
	(uint32)UserFunc1,
	(uint32)UserFunc2,
	(uint32)UserFunc3,
	(uint32)UserFunc4
};



	/* offset for which library (jump table) index should be used */
#define LibraryNumber		3

InitUserLibrary()
{
	DCIheader.DCI_FunctionTable[LibraryNumber] = (uint32)&DCI_UserLib_Table[0];
}



	/* The following are stub function definitions for the library
	 * functions.  If the actual library functions are contained in another
	 * file(s), then simply erase the functions here.
	 */
UserFunc1()
{
}
UserFunc2()
{
}
UserFunc3()
{
}
UserFunc4()
{
}
	
